# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# --with reply_plugin
#	Default: --without
# Missing deps (perl(Reply::Plugin))
# Marked as unstable (cf. lib/Reply/Plugin/TypeTiny.pm)
%bcond_with reply_plugin

Name:		perl-Type-Tiny
Version:	1.012000
Release:	1.%{__distinit}%{__distvers}
Summary:	Tiny, yet Moo(se)-compatible type constraint
License:	GPL+ or Artistic
URL:		http://typetiny.toby.ink/
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Type-Tiny-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(CPAN::Meta::Requirements) >= 2.0
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.17
# Module Runtime
BuildRequires:	perl(B)
BuildRequires:	perl(Exporter::Tiny) >= 1.000000
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(Text::Balanced)
BuildRequires:	perl(utf8)
BuildRequires:	perl(warnings)
# Optional Module Runtime
BuildRequires:	perl(B::Deparse)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Devel::LexAlias) >= 0.05
BuildRequires:	perl(Devel::StackTrace)
BuildRequires:	perl(mro)
BuildRequires:	perl(re)
BuildRequires:	perl(Ref::Util::XS) >= 0.100
%{?with_reply_plugin:
BuildRequires:	perl(Reply::Plugin)}
# Prefers Sub::Util, falls back to Sub::Name
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl(Sub::Util)
Requires:	perl(Sub::Util)
%else
BuildRequires:	perl(Sub::Name)
Requires:	perl(Sub::Name)
%endif
%{?with_reply_plugin:
BuildRequires:	perl(Term::ANSIColor)}
BuildRequires:	perl(Type::Tie)
# Test Suite
BuildRequires:	perl(Config)
BuildRequires:	perl(constant)
BuildRequires:	perl(Encode)
BuildRequires:	perl(lib)
BuildRequires:	perl(Math::BigFloat)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Test::Requires)
# Optional Tests
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Benchmark)
BuildRequires:	perl(Devel::Cover)
BuildRequires:	perl(Devel::Hide)
BuildRequires:	perl(Exporter) >= 5.59
%if 0%{?fedora} > 23 || 0%{?rhel} > 7
BuildRequires:	perl(Function::Parameters) >= 1.0103
%endif
BuildRequires:	perl(IO::File)
BuildRequires:	perl(IO::String)
BuildRequires:	perl(JSON::PP) >= 2.27105
%if 0%{?fedora} > 27 || 0%{?rhel} > 7
BuildRequires:	perl(match::simple)
%endif
BuildRequires:	perl(Method::Generate::Accessor)
BuildRequires:	perl(Moo) >= 1.006000
BuildRequires:	perl(Moo::Role)
BuildRequires:	perl(Moose) >= 2.1210
BuildRequires:	perl(Moose::Meta::TypeCoercion)
BuildRequires:	perl(Moose::Meta::TypeCoercion::Union)
BuildRequires:	perl(Moose::Meta::TypeConstraint)
BuildRequires:	perl(Moose::Meta::TypeConstraint::Class)
BuildRequires:	perl(Moose::Meta::TypeConstraint::DuckType)
BuildRequires:	perl(Moose::Meta::TypeConstraint::Enum)
BuildRequires:	perl(Moose::Meta::TypeConstraint::Union)
BuildRequires:	perl(Moose::Util::TypeConstraints)
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl(MooseX::Getopt) >= 0.63
%endif
BuildRequires:	perl(MooseX::Types)
%if 0%{?fedora} > 16 || 0%{?rhel} > 7
BuildRequires:	perl(MooseX::Types::Common) >= 0.001004
%endif
BuildRequires:	perl(MooseX::Types::Moose)
BuildRequires:	perl(Mouse) >= 1.000
BuildRequires:	perl(Mouse::Meta::TypeConstraint)
BuildRequires:	perl(Mouse::Util)
BuildRequires:	perl(Mouse::Util::TypeConstraints)
%if 0%{?fedora} > 16 || 0%{?rhel} > 6
BuildRequires:	perl(MouseX::Types) >= 0.06
BuildRequires:	perl(MouseX::Types::Moose)
%endif
BuildRequires:	perl(Object::Accessor) >= 0.30
%if 0%{?fedora} > 33 || 0%{?rhel} > 8
BuildRequires:	perl(Return::Type) >= 0.007
%endif
BuildRequires:	perl(Role::Tiny)
BuildRequires:	perl(Role::Tiny::With)
BuildRequires:	perl(Specio)
%if 0%{?fedora} > 23 || 0%{?rhel} > 7
BuildRequires:	perl(Sub::Exporter::Lexical) >= 0.092291
%endif
BuildRequires:	perl(Sub::Quote)
BuildRequires:	perl(Test::LeakTrace)
BuildRequires:	perl(Test::Memory::Cycle)
BuildRequires:	perl(Test::Moose)
BuildRequires:	perl(Test::Tester) >= 0.109
BuildRequires:	perl(Test::Warnings) >= 0.005
BuildRequires:	perl(threads)
BuildRequires:	perl(Tie::Array)
BuildRequires:	perl(Tie::Hash)
BuildRequires:	perl(Tie::Scalar)
%if 0%{?fedora} > 23
BuildRequires:	perl(Types::Path::Tiny)
%endif
%if 0%{?fedora} > 23 || 0%{?rhel} > 7
BuildRequires:	perl(Validation::Class) >= 7.900017
BuildRequires:	perl(Validation::Class::Simple)
%endif
%endif
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(B::Deparse)
Requires:	perl(Carp)
Requires:	perl(Data::Dumper)
Requires:	perl(mro)
Requires:	perl(re)
Requires:	perl(Text::Balanced)
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
Recommends:	perl(Devel::LexAlias) >= 0.05
Recommends:	perl(Devel::StackTrace)
Recommends:	perl(Ref::Util::XS) >= 0.100
Recommends:	perl(Type::Tie)
%else
Requires:	perl(Devel::LexAlias) >= 0.05
Requires:	perl(Devel::StackTrace)
Requires:	perl(Ref::Util::XS) >= 0.100
Requires:	perl(Type::Tie)
%endif

# Optional Modules not yet available
#TODO: BuildRequires:	perl(Class::InsideOut) >= 1.13
#TODO: BuildRequires:	perl(Kavorka)
#TODO: BuildRequires:	perl(Moops)
#TODO: BuildRequires:	perl(MooX::TypeTiny)
#TODO: BuildRequires:	perl(MouseX::Types::Common) >= 0.001000
#TODO: BuildRequires:	perl(Regexp::Util) >= 0.003
#TODO: BuildRequires:	perl(Switcheroo)
#TODO: BuildRequires:	perl(Type::Tiny::XS)
#TODO: BuildRequires:	perl(Types::XSD::Lite)

%description
Type::Tiny is a tiny class for creating Moose-like type constraint objects
that are compatible with Moo, Moose and Mouse.

%package -n perl-Test-TypeTiny
Summary:	Test::TypeTiny module

%description -n perl-Test-TypeTiny
Test::TypeTiny module.

%prep
%setup -q -n Type-Tiny-%{version}

# Remove bundled modules Test::Fatal, Test::Requires and Try::Tiny
rm -r ./inc/
sed -i -e '/^inc\//d' MANIFEST

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test EXTENDED_TESTING=1

%files
%if 0%{?_licensedir:1}
%license COPYRIGHT LICENSE
%else
%doc COPYRIGHT LICENSE
%endif
%doc Changes CREDITS NEWS README
%{perl_vendorlib}/Devel/
%{perl_vendorlib}/Error/
%{perl_vendorlib}/Eval/
%{!?with_reply_plugin:
%exclude }%{perl_vendorlib}/Reply/
%{perl_vendorlib}/Type/
%{perl_vendorlib}/Types/
%{_mandir}/man3/Devel::TypeTiny::Perl56Compat.3*
%{_mandir}/man3/Devel::TypeTiny::Perl58Compat.3*
%{_mandir}/man3/Error::TypeTiny.3*
%{_mandir}/man3/Error::TypeTiny::Assertion.3*
%{_mandir}/man3/Error::TypeTiny::Compilation.3*
%{_mandir}/man3/Error::TypeTiny::WrongNumberOfParameters.3*
%{_mandir}/man3/Eval::TypeTiny.3*
%{!?with_reply_plugin:
%exclude }%{_mandir}/man3/Reply::Plugin::TypeTiny.3*
%{_mandir}/man3/Type::Coercion.3*
%{_mandir}/man3/Type::Coercion::FromMoose.3*
%{_mandir}/man3/Type::Coercion::Union.3*
%{_mandir}/man3/Type::Library.3*
%{_mandir}/man3/Type::Params.3*
%{_mandir}/man3/Type::Parser.3*
%{_mandir}/man3/Type::Registry.3*
%{_mandir}/man3/Type::Tiny.3*
%{_mandir}/man3/Type::Tiny::Class.3*
%{_mandir}/man3/Type::Tiny::ConstrainedObject.3*
%{_mandir}/man3/Type::Tiny::Duck.3*
%{_mandir}/man3/Type::Tiny::Enum.3*
%{_mandir}/man3/Type::Tiny::Intersection.3*
%{_mandir}/man3/Type::Tiny::Manual.3*
%{_mandir}/man3/Type::Tiny::Manual::AllTypes.3*
%{_mandir}/man3/Type::Tiny::Manual::Coercions.3*
%{_mandir}/man3/Type::Tiny::Manual::Contributing.3*
%{_mandir}/man3/Type::Tiny::Manual::Installation.3*
%{_mandir}/man3/Type::Tiny::Manual::Libraries.3*
%{_mandir}/man3/Type::Tiny::Manual::NonOO.3*
%{_mandir}/man3/Type::Tiny::Manual::Optimization.3*
%{_mandir}/man3/Type::Tiny::Manual::Params.3*
%{_mandir}/man3/Type::Tiny::Manual::Policies.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithClassTiny.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo2.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoo3.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMoose.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithMouse.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithOther.3*
%{_mandir}/man3/Type::Tiny::Manual::UsingWithTestMore.3*
%{_mandir}/man3/Type::Tiny::Role.3*
%{_mandir}/man3/Type::Tiny::Union.3*
%{_mandir}/man3/Type::Tiny::_HalfOp.3*
%{_mandir}/man3/Type::Utils.3*
%{_mandir}/man3/Types::Common::Numeric.3*
%{_mandir}/man3/Types::Common::String.3*
%{_mandir}/man3/Types::Standard.3*
%{_mandir}/man3/Types::Standard::ArrayRef.3*
%{_mandir}/man3/Types::Standard::CycleTuple.3*
%{_mandir}/man3/Types::Standard::Dict.3*
%{_mandir}/man3/Types::Standard::HashRef.3*
%{_mandir}/man3/Types::Standard::Map.3*
%{_mandir}/man3/Types::Standard::ScalarRef.3*
%{_mandir}/man3/Types::Standard::StrMatch.3*
%{_mandir}/man3/Types::Standard::Tied.3*
%{_mandir}/man3/Types::Standard::Tuple.3*
%{_mandir}/man3/Types::TypeTiny.3*

%files -n perl-Test-TypeTiny
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::TypeTiny.3*

%changelog
* Wed Oct 28 2020 Paul Howarth <paul@city-fan.org> - 1.012000-1
- Update to 1.012000
  - List processing methods (grep, map, etc.)
  - Type::Utils::is() and Type::Utils::assert()
  - Improvements to Types::TypeTiny
  - Type::Params now provides an ArgsObject type
  - ArrayLike and HashLike types now parameterizable
  - Type::Library -extends and -utils flags

* Fri Sep  4 2020 Paul Howarth <paul@city-fan.org> - 1.010006-1
- Update to 1.010006
  - Eliminate recursion warnings when Type::Parser needs to parse complex types
    (CPAN RT#121957)
  - Better handling of coercions for pre-declared types in Type::Library; the
    type objects created before the type was properly defined will now lazily
    attempt to find coercions from the properly defined type once it becomes
    available

* Wed Aug 26 2020 Paul Howarth <paul@city-fan.org> - 1.010005-1
- Update to 1.010005
  - Improvements to $AvoidCallbacks support for
    Type::Tiny::{Class,Role,Duck,Enum,Union,Intersection}, and LaxNum, Ref,
    RegexpRef, FileHandle, Object, Overload, and Tied types from Types::Standard

* Tue Aug 18 2020 Paul Howarth <paul@city-fan.org> - 1.010004-1
- Update to 1.010004
  - Fix XSifying Enum[] where the strings contain certain non-word characters
    - https://github.com/tobyink/p5-type-tiny-xs/pull/12
    - https://github.com/tobyink/p5-type-tiny/pull/59
  - Type::Params compile_named using both the head and named_to_list options
    would cause compilation error (CPAN RT#132419)
  - Work around CPAN RT#121957 by avoiding attempting to XSify Enum type
    constraints with more than 50 possible strings
  - Link to HTTPS version of Type::Tiny web page

* Sun Aug  9 2020 Paul Howarth <paul@city-fan.org> - 1.010003-1
- Update to 1.010003
 - ClassName type constraint should treat empty @ISA as if no @ISA were
   defined, like Type::Tiny::XS (CPAN RT#132583)
 - Fix for Type::Tiny->can called as a class method (GH#57)
 - Fix predeclared types in Type::Library (GH#58)
 - Document some edge cases for Types::Standard Int (CPAN RT#132754)

* Mon Jun 29 2020 Paul Howarth <paul@city-fan.org> - 1.010002-3
- Perl 5.32 rebuild

* Sat May  2 2020 Paul Howarth <paul@city-fan.org> - 1.010002-1
- Update to 1.010002
  - Better bareword handling on Perl < 5.14 (CPAN RT#132455)
  - If Scalar::Util was below 1.18, the LaxNum type from Types::Standard would
    accept blobs as being numbers; this is now fixed (CPAN RT#132426)

* Mon Mar 16 2020 Paul Howarth <paul@city-fan.org> - 1.010001-1
- Update to 1.010001
  - MooX::Pression mentions in documentation now refer to Zydeco
  - Test suite passes in cperl, albeit with warnings

* Thu Feb 20 2020 Paul Howarth <paul@city-fan.org> - 1.010000-1
- Update to 1.010000
  - Subclasses of Moose::Meta::TypeConstraint are now converted to the
    appropriate subclasses of Type::Tiny by Types::TypeTiny::to_TypeTiny,
    instead of always being converted to the base class; this improves inlining
    amongst other things
  - When types are declared by Type::Library's -declare import parameter, the
    temporary subs installed can now generate placeholder type constraints
    that allow the types to be used in recursive type definitions
  - Added: Type::Tiny::Enum now has an 'as_regexp' method
  - In some edge cases, the regexps used by Type::Tiny::Enum will now be
    slightly faster
  - More tests for recursively defined type constraints
  - Added: Type::Params now supports 'head' and 'tail' options for 'compile',
    'compile_named', and 'compile_named_oo'
  - Parameterized 'Ref' type constraint in Types::Standard now checks that its
    parameter is a known Perl ref type
  - Fix importing multiple type libraries into a type registry at once
    (CPAN RT#131744)
  - Type::Params on Perl older than 5.10 now uses its own B::perlstring
    implementation to quote strings instead of using B::cstring
  - Mention MooX::Pression in documentation
  - Fix typo in documentation of 'my_methods'
  - Correct documentation of slurpy with compile_named (CPAN RT#131720)

* Thu Jan 30 2020 Paul Howarth <paul@city-fan.org> - 1.008005-1
- Update to 1.008005
  - Remove some Perl 5.012+ syntax from test suite

* Thu Jan 30 2020 Paul Howarth <paul@city-fan.org> - 1.008004-1
- Update to 1.008004
  - When possible, inject 'package Type::Tiny' in generated inline code that
    has an appropriate lexical scope to insert it into; this will (mostly)
    avoid inline code mistakenly using overridden versions of CORE:: functions
  - to_TypeTiny will now cowardly refuse to inline Moose types if they have
    anything in their inline environment

* Tue Jan 14 2020 Paul Howarth <paul@city-fan.org> - 1.008003-1
- Update to 1.008003
  - Makefile.PL will now bail out on cperl if AUTOMATED_TESTING environment
    variable is set to true
  - Added: Type::Registry can now have a parent registry
  - Update copyright dates to 2020

* Mon Jan 13 2020 Paul Howarth <paul@city-fan.org> - 1.008002-1
- Update to 1.008002
  - Fix bareword errors if certain Type::Tiny subclasses were loaded prior to
    Type::Tiny (CPAN RT#131401)
  - Fix some typos in the documentation
  - Type::Tiny didn't accept string constraints for parameterizable type
    constraints; this was not a documented restriction and didn't seem to serve
    any purpose, so the restriction has been lifted (CPAN RT#131238)

* Sat Dec 28 2019 Paul Howarth <paul@city-fan.org> - 1.008001-1
- Update to 1.008001
  - Types::TypeTiny honours $Type::Tiny::AvoidCallbacks
  - Types::TypeTiny now better mocks Type::Library, offering is_* and assert_*
    functions for export
  - Use improved inline_assert when building the coderef for &{$type}
    overloading

* Wed Dec 11 2019 Paul Howarth <paul@city-fan.org> - 1.008000-1
- Update to 1.008000
  - Type::Tiny has a website: http://typetiny.toby.ink/
  - Resolved all bugs from RT
    - Type::Tiny::Enum now has a 'unique_values' method (CPAN RT#129650)
    - Added Type::Params named_to_list feature (CPAN RT#128337)
  - Completed everything on TODO
  - Rewrite of the manual
  - Lots more test cases (now almost 14,000 test cases total!)
  - wrap_methods/wrap_subs in Type::Params

* Wed Nov 13 2019 Paul Howarth <paul@city-fan.org> - 1.006000-1
- Update to 1.006000
  Bug Fixes
  - Fix spelling in error message for Types::Common::String LowerCaseSimpleStr
    (GH#47)
  Documentation
  - Fix Type::Params documentation error (GH#45)
  - Fix Types::Standard documentation error: incorrect third-party module name
    (GH#46)
  - Minor correction to POD header for Type::Params (GH#43)
  - Types::Standard documentation fix (GH#48)
  - Links to Type::Tiny on GitHub/Travis/AppVeyor/Coveralls in Type::Tiny pod
  Packaging
  - Bump minimum required version of Exporter::Tiny to 1.000000
  - Type::Tiny::XS 0.016 is recommended
  Other
  - Added: Type::Params multisig function now supports custom error messages
    (GH#44)
  - Added: Types::Standard ArrayRef parameterized type can now take a second
    parameter, the minimum array length
  - Added: Type::Library now supports 'of' and 'where' options when importing
    type constraints
  - Added: Type::Params named_to_list feature (CPAN RT#128337)
  - Added: Type::Tiny::Enum now has a 'unique_values' method (CPAN RT#129650)
  - Better implementation of is_subtype_of/is_supertype_of and related
    functions
  - Eval::TypeTiny's API is now considered to be stable
  - Tidy up Type::Tiny namespace a little by fully-referencing some functions
    instead of importing them
  - Tweaks to Type::Tiny and Type::Coercion to avoid unnecessarily loading
    overload.pm and overloading.pm
  - Type::Params signatures with slurpy hashrefs now allow true hashrefs to be
    passed to them
  - Types::TypeTiny::TypeTiny->has_coercion is now true
  - Fix Types::Standard's LazyLoad implementation
  - Don't use Int from Type::Tiny::XS unless version 0.016 is available
    (CPAN RT#130411)
  - Eliminate memory cycles created by coderef overloading in Type::Tiny and
    Type::Coercion (CPAN RT#130823)
  - The 'values' attribute of Type::Tiny::Enum now preserves order
    (CPAN RT#129650)
  Test Suite
  - Improve test coverage

* Wed Oct 23 2019 Paul Howarth <paul@city-fan.org> - 1.004004-6
- Include many more optional modules

* Fri Jul 26 2019 Paul Howarth <paul@city-fan.org> - 1.004004-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Wed Jun  5 2019 Paul Howarth <paul@city-fan.org> - 1.004004-4
- Perl 5.30 rebuild

* Wed Jan  9 2019 Paul Howarth <paul@city-fan.org> - 1.004004-1
- Update to 1.004004
  Bug Fixes 
  - Fix spelling in error message for Types::Common::String LowerCaseSimpleStr
    (GH#47)
  - Depend on Exporter::Tiny 0.040; older versions don't provide all the
    functions Type::Library needs.
  Documentation
  - Fix Type::Params documentation error (GH#45)
  - Fix Types::Standard documentation error: incorrect third-party module name
    (GH#46)

* Wed Aug  1 2018 Paul Howarth <paul@city-fan.org> - 1.004002-1
- Update to 1.004002
  - Types::Standard::FileHandle has a looser definition, more consistent with
    Mouse and Type::Tiny::XS
  - Types::Standard::Bool has a stricter definition, but also has a built-in
    coercion from a very loose definition
  - Type::Params now has 'compile_named_oo'
  - Type::Params supports defaults for missing parameters
  - Types::Common::Numeric includes IntRange and NumRange
  - Types::Common::String includes StrLength
  - Type::Tiny now allows types to be marked as deprecated
  - Improvements to Eval::TypeTiny
  - Various bug fixes
  - Improved test suite
- Switch upstream from search.cpan.org to metacpan.org

* Wed Apr 18 2018 Paul Howarth <paul@city-fan.org> - 1.002002-1
- Update to 1.002002
  Bug Fixes
  - Compatibility with constants and with CV-in-stash optimisation
    (CPAN RT#123408)

* Thu Mar 29 2018 Paul Howarth <paul@city-fan.org> - 1.002001-3
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Sun Jun 25 2017 Paul Howarth <paul@city-fan.org> - 1.002001-2
- Don't pull in dependencies for optional tests when bootstrapping

* Mon Jun 19 2017 Paul Howarth <paul@city-fan.org> - 1.002001-1
- Update to 1.002001
  Test Suite
  - Skip t/30-integration/Moose/native-attribute-traits.t on older Moose
    because Test::Moose is broken
  Packaging
  - Ref::Util::XS 0.100 should be recommended, not 0.200 (which doesn't exist
    yet) (CPAN RT#121981)

* Thu Jun  1 2017 Paul Howarth <paul@city-fan.org> - 1.002000-1
- Update to 1.002000
  Back Compat
  - RegexpRef now accepts blessed objects if $object->isa('Regexp') returns
    true
  Bug Fixes
  - Fix for Type::Registry::DWIM (CPAN RT#98458)
  - Fix issues with coercions and native attribute traits with some oldish
    versions of Moose on oldish versions of Perl (CPAN RT#98159)
  - Fix short-circuiting optimizations for parameterized HashRef, ArrayRef,
    ScalarRef and Map type constraints (CPAN RT#99312)
  - Inlined version of Types::Standard::Int should check that the value is not
    a reference
  - Attempting ArrayRef[Int, Int] or similar now throws an exception
    (CPAN RT#105299)
  - 02-api.t should check version of Moose available (GH#20)
  - 20-unit/Type-Utils/warnings.t should check version of Test::Warnings
    (GH#21)
  - Fix minor typos in documentation for Types::Standard (GH#30)
  - Fix variable name typo in documentation for Type::Params (GH#37)
  - Localize $SIG{__DIE__} in Type::Registry (CPAN RT#100780)
  - Type::Params should make sure Type::Utils is loaded before calling
    english_list()
  - Type constraints like Tuple[Int] shouldn't report they have a coercion if
    Int doesn't have a coercion
  - Fixed crazy amount of UTF-8 warnings from Type::Params on Perl 5.6.x and
    Perl 5.8.x (CPAN RT#101582, GH#16)
  - Fix HashRef[Str]|Undef|Str parsing on Perl < 5.14 (CPAN RT#121764)
  Documentation
  - Updated NEWS file
  - Updated TODO file
  - Updates to Type::Tiny::Manual::UsingWithMoose,
    Type::Tiny::Manual::UsingWithMoo, and Type::Tiny::Manual::UsingWithMouse
  - Comparison of Type::Params with new(ish) CPAN module
    Params::ValidationCompiler
  - Show example of how to set defaults for parameters with Type::Params
  - Rearrange the examples directory in the distribution
  - Include page-numbers.pl example
  Test Suite
  - Make some of the test case skip_all bits more ambitious; test older
    versions of Moose and Moo than we were testing before
  - Fix annoying warning message in test suite with recent versions of
    Exporter::Tiny
  - Bundle a test case for GH#14
  - t/00-begin.t will now work around ANDK's apparently broken XS testing
    environment
  Other
  - Added: Type::Params now provides 'compile_named' and 'validate_named'
    functions, which do the same thing as 'compile' and 'validate' but are
    better for named arguments
  - Updated: If the shiny new core Sub::Util is available, use it instead of
    Sub::Name (the former is smaller)
  - Updated: Want Type::Tiny::XS 0.011
  - 'Type::Utils::dwim_type' now allows more control over fallback behaviours
  - Lazy-load Text::Balanced in Type::Parser (many parses don't even need it)
  - Lazy-load Type::Tiny::Union in Type::Params
  - Make equals/is_a_type_of/is_subtype_of/is_supertype_of in Type::Tiny::Union
    work more like Moose::Meta::TypeConstraint::Union
  - Improved error location reporting for Moo (GH#35)
  - Updated: NumericCode now coerces from strings with whitespace in them, like
    MooseX::Types::Common::Numeric (GH#22)
  - Allow Type::Tiny's 'constraint' parameter to be a string of Perl code.
  - Added: Type::Params' 'multisig' function now sets a variable
    '${^TYPE_PARAMS_MULTISIG}' to indicate which signature succeeded
  - Optimization of Type::Params positional parameter checking for simple cases
    with no slurpy parameter and no coercions
  - Optimizations for Tuple and StrMatch type constraints from Types::Standard
  - Added: Named parameter validation benchmarking script
  - Rewrite some benchmarking scripts to use Benchmark::Featureset::ParamCheck
  - Use Ref::Util::XS (if it's installed) to speed up certain type checks
  - Added: Types::Standard now has a CycleTuple type
  - StrMatch will use Regexp::Util (if available) to inline regular expressions
    more sensibly
  - Include trailing line break at the end of stringified version of some
    exceptions
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.96
  - BR: perl(Test::Warnings) unconditionally

* Tue Jan 31 2017 Paul Howarth <paul@city-fan.org> - 1.000006-1
- Update to 1.000006
  - Fix escaping within q{...} in a test case (CPAN RT#114386)

* Mon Jan  9 2017 Paul Howarth <paul@city-fan.org> - 1.000005-8
- Test::Warnings now available back to F-9

* Fri Oct 14 2016 Paul Howarth <paul@city-fan.org> - 1.000005-7
- BR: perl-generators where available
- Simplify find command using -delete
- Re-enable use of Devel::Cover for all builds

* Wed Jul  1 2015 Paul Howarth <paul@city-fan.org> - 1.000005-2
- Avoid use of Devel::Cover with Perl 5.22 onwards for now
  (https://github.com/pjcj/Devel--Cover/issues/126)

* Sun Oct 26 2014 Paul Howarth <paul@city-fan.org> - 1.000005-1
- Update to 1.000005
  - Fix short-circuiting optimizations for parameterized HashRef, ArrayRef,
    ScalarRef and Map type constraints (CPAN RT#99312)
  - Fix annoying warning message in test suite with recent versions of
    Exporter::Tiny

* Thu Oct  2 2014 Paul Howarth <paul@city-fan.org> - 1.000004-3
- Import from Fedora

* Thu Sep 04 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.000004-2
- Perl 5.20 rebuild

* Thu Sep 04 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000004-1
- Upstream update

* Mon Sep 01 2014 Jitka Plesnikova <jplesnik@redhat.com> - 1.000003-2
- Perl 5.20 rebuild

* Sun Aug 31 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000003-1
- Upstream update

* Fri Aug 22 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000002-1
- Upstream update
- Update deps

* Mon Aug 18 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 1.000000-1
- Upstream update

* Thu Jul 24 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.046-1
- Upstream update

* Mon Jun 23 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.044-1
- Upstream update
- Spec file cosmetics
- BR: perl(Test::Moose), perl(MooseX::Getopt)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.042-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Apr 08 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.042-1
- Upstream update
- Split out perl(Test::TypeTiny) to avoid deps on perl(Test::*)

* Fri Mar 21 2014 Ralf Corsépius <corsepiu@fedoraproject.org> - 0.040-1
- Initial Fedora package
